%Solution for Homework 1 Exercise 8

%Given a vector x which contains zeros (e.g., x = [3, -1, 0, 2, 5, 0, 7]), 
%find how to delete zeros from it.

%x = [3, -1, 0, 2, 5, 0, 7];
%in this example you can create the vector x in different ways. An
%alternative is to create the vector filling it with random integer numbers.
%The function randi does that. You have only to specify the interval for the
%values of the vector and the size of the vector. Use the help command to
%discover the sintax of the function

IMIN = -10;
IMAX = 10;
x = randi([IMIN,IMAX],1,10);

disp(x);

len = length(x);

mask = zeros(1, len);	% here we create a mask vector containing zeros. 
					%We will use the mask to discover the position of zeros in x

x = x(x~=mask);		% x~=mask returns the indexes of the elements that are different from zero.
					% x(x~=mask) is the set of elements of x that are
              		% different from zero. 
              		% Here we rewrite the x vector thus eliminating the elements equal to 0.

disp(x);
                    
len1 = length(x); 

res = (len1 ~= len);	% if the length of x has changed, then some zero has been removed. 

fprintf('res = %d (if res=1 we removed all zeros, otherwise no zero was in x)\n', res);